/*
 * fca-rreq.h  -- Helen J. Wang
 */

#ifndef mash_fca_rreq_h 
#define mash_fca_rreq_h

#include "fc.h"
#include "srm/session-srm.h"
#include "fca-pkt.h"
#include <tclcl.h>

class FCARepairReply;

class FCARepairRequest : public SRM_Request, public FCA_Packet {
public:
  FCARepairRequest() {}
  virtual ~FCARepairRequest() {}
  virtual int fill_ADU() {
    /* REVIEW: get the len right! */
    return fill_ADU(pb_->data+sizeof(srmhdr), SRM_MTU);        
  }
  int fill_ADU(Byte* pb, int len);
  int command(int argc, const char*const* argv);
};


class FCARepairReply : public SRM_Reply, public FCA_Packet {
public:
  FCARepairReply() {};
  virtual ~FCARepairReply() {};
  /* REVIEW: get the len right! */
  virtual int fill_ADU() {
    return fill_ADU(pb_->data+sizeof(srmhdr), SRM_MTU);        
  }
  /* fills as much as possible, shrunk itself after that */
  int fill_ADU(Byte* pb, int len);
  int command(int argc, const char*const* argv);
};


#endif /* #ifndef mash_fca_rreq_h */
