#include "mc/pend-mc.h"
#include "mc/manager-mc.h"
#include "mc/common-mc.h"

/* 
 * Format: same as reply except no data and a length
 *         and offset of 0 to indicate that this is just
 *         a reply-pending message -- not a full-blown. 
 *         reply. 
 */
//virtual
int
MC_Pending::fill_ADU(void) 
{
	dprintf(stderr, "PENDING::FILL_ADU():%s \n", key_);
	/* forward the pointer; should be done in srm lib but isn't*/
	char *pkt = (char *)(pb_->data+sizeof(srmhdr));

	/* make sure we still need to send this out */
	Tcl& tcl = Tcl::instance();
	tcl.evalf("%s get_pending %s", mcmgr_->name(), key_);
	if (strcmp(tcl.result(), "-1") == 0) {
		dprintf(stderr, " ALREADY CANCELLED\n");
		this->cancel();
		return 0;
	}

	int keylen = strlen(key_);
	*(u_int32_t*)&pkt[0] = htonl(0);
	*(u_int32_t*)&pkt[4] = htonl(0);
	*(u_int16_t*)&pkt[8] = htons(keylen);	
	memcpy((char*)&pkt[10], key_, keylen);

//	tcl.evalf("mc_trace_p %s", key_);

	this->cancel();
	tcl.evalf("%s launch %s %s", mcmgr_->name(), key_, http_server_);
	
	return keylen + 10;
}



