class LogService : public TclObject {
public:
  LogService() : TclObject(), cur_rtp_record_(0),
    cur_comm_record_(0), on_flag_(0) {};
  
  int command(int argc, const char*const* argv);
  void log_rtp_pkt(pktbuf *pb);
  int check_time(int rtp_index, int comm_index);
  void gen_log(char *mesg);

  int cur_rtp_record_;
  int cur_comm_record_;
  
  int on_flag_;

  class RTPPktEntry {
  public:
    u_int16_t flags_;
    u_int16_t seq_no_;
    u_int32_t ts_;
    u_int32_t ssrc_;
    int length_;
    struct timeval log_ts_;
  };
  
  class GraphCommEntry {
  public:
    char in_or_out_;
    char delivered_;
    char mesg_[100];
    struct timeval log_ts_;
  };

  RTPPktEntry rtp_entries_[9000];
  GraphCommEntry gcomm_entries_[9000];

};

extern LogService logger;
