import DaliSubprogram

Class EdgeDetectSubprogram -superclass DaliSubprogram

EdgeDetectSubprogram instproc init {args} {
    eval $self next $args;

    # Set up inputs
    
    $self instvar input_id_list_;
    $self instvar input_info_;
    
    lappend input_id_list_ i1
    
    set input_info_(i1,spec) "";
    set input_info_(i1,trigger) 0;
    set input_info_(i1,buffertype) Uncompressed;
    set input_info_(i1,buffername) [new VidRep/Uncompressed];
    set input_info_(i1,decoder) "";
    
    # Set up outputs
    
    $self instvar output_id_list_;
    $self instvar output_info_;
    
    lappend output_id_list_ o1;
    
    set output_info_(o1,spec) "";
    set output_info_(o1,buffertype) Uncompressed;
    set output_info_(o1,buffername) [new VidRep/Uncompressed];
    set output_info_(o1,encoder) "";
    set output_info_(o1,format) JPEG;
    set output_info_(o1,vagent) "";
    
    # Set up parameters
    
    $self instvar parameter_id_list_;
    $self instvar parameter_info_;

    set parameter_id_list_ "";
}

EdgeDetectSubprogram instproc trigger {} {
    $self instvar input_info_;
    $self instvar output_info_;
    $self instvar init_done_;
    $self instvar smooth_;

    set in_frame $input_info_(i1,buffername);
    set out_frame $output_info_(o1,buffername);
    
    if {![info exists init_done_]} {
	if {[$in_frame set w_] == 0} {
	    return;
	}
	$out_frame copy_geometry $in_frame;
	if {$output_info_(o1,format) == "JPEG"} {
	    $out_frame set h_subsample_ 2;
	    $out_frame set v_subsample_ 1;
	} else {
	    $out_frame set h_subsample_ 2;
	    $out_frame set v_subsample_ 2;
	}
	$out_frame allocate;
	set init_done_ 1;
	
	set out_cr [$out_frame get_cr_name];
	set out_cb [$out_frame get_cb_name];
	byte_set $out_cr 128
	byte_set $out_cb 128	
	
	set smooth_ [new VidRep/Uncompressed];
	$smooth_ copy_geometry $in_frame;
	$smooth_ allocate;
    }

    set in_l [$in_frame get_lum_name];
    set out_l [$out_frame get_lum_name];
    set smooth_l [$smooth_ get_lum_name];

    byte_smooth $in_l $smooth_l 2;
    byte_edge_detect_canny $smooth_l $out_l 5 10;

    $out_frame set ts_ [$in_frame set ts_];

    set encoder $output_info_(o1,encoder);

    if {$encoder != ""} {
	$encoder recv $out_frame;
    }
    $self send_completion_token;
}
