import RTPApplication
import TemporalInterleaver

Class FXTInterApp -superclass RTPApplication

FXTInterApp instproc init args {
    global kpatel_debug;

    set kpatel_debug [new LogService];
    $kpatel_debug on;

    $self next fx_tinter_app

    $self init_resources;

    eval [$self options] parse_args $args;

    $self instvar tinter_obj_
    
    set tinter_obj_ [new TemporalInterleaver [$self get_option comm_id] [$self get_option cntrl_spec]];

    if {[$self get_option create_ui] != 0} {
	global tk_version;
	if {[info exists tk_version]} {
	    puts "creating ui"
	    import TInterUI

	    $self instvar tinter_ui_;

	    set tinter_ui_ [new TInterUI ""];

	    $tinter_ui_ attach $tinter_obj_;
	}
    }
}

FXTInterApp instproc init_resources {} {
    [$self options] register_option -comm_id comm_id
    [$self options] register_option -cntrl_spec cntrl_spec
    [$self options] register_option -create_ui create_ui
    [$self options] register_option -gen_spec gen_spec

    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 30000000
    $self add_option comm_id ti
    $self add_option cntrl_spec 224.3.2.1/22334/16
    $self add_option create_ui 0
    $self add_option gen_spec 224.5.7.1;
}

set app [new FXTInterApp $argv];

puts "Interleaver running on [exec hostname]";

#if {![info exists tk_version]} {
#    vwait forever;
#}
