
import TCP

Class SdforServer -superclass TCP

SdforServer set methods_ [list get advertise]

SdforServer public init {parent} {
    $self instvar cache_ source_ buffer_
    set cache_ [$parent set cache_]
    set source_ [$parent set source_]
    set buffer_ ""
    $self next
}

SdforServer public recv s {
    $class instvar methods_
    $self instvar buffer_

    append buffer_ $s
    append buffer_ "\n"
    if {$s != ""} { return }

    set i [string first " " $buffer_]
    set cmd [string range $buffer_ 0 [expr $i-1]]
    switch $cmd {
	subscribe {
	    $self instvar cache_
	    $cache_ subscribe $self
	}

	advertise {
	    set msg [string range $buffer_ [expr $i + 1] end]
	    $self advertise $msg
	}

	default {
	    #XXX
	    #$self send "Unrecognized command \"$cmd\"\n\n"
	    $self warn "Unrecognized command \"$cmd\""
	}
    }
}

SdforServer public advertise {text} {
    $self instvar source_
    
    #XXX
    set parser [$source_ set sdp_]

    set objs [$parser parse $text]
    foreach o $objs {
	set prog [new Program $o]
	$source_ announce $prog
    }

    #XXX still need to do:
    #  - write to stable storage and readvertise when restarted
    #  - stop announcing when timed out
    #  - authentication stuff from the mm98 paper
}

SdforServer public shutdown {} {
    $self instvar cache_
    $cache_ unsubscribe $self
}



import ERSServer

Class ERSServer/Sdfor -superclass ERSServer

ERSServer/Sdfor public init {port spec} {
	$self instvar server_port_
	set server_port_ $port
	$self next $spec
}

ERSServer/Sdfor public build_reply {data} {
	$self instvar net_ server_port_
	set addr [$net_ interface]
	return "$addr/$server_port_"
}
